<template>
  <div style="margin: 3rem">
    <header style="margin:10rem 6rem 3rem 6rem">
      <ReturnButton  v-on:clickEvent="viewList" title="Regresar" :offsetArrow="21" :spanTitle="2" class="text-end" style="margin-bottom: 2.5rem"></ReturnButton>
      <el-row >
        <el-col :span="17" :offset="7" class="text-end">
          <!-- <el-button class="text-orange btn-edit-report" @click="viewRev">Editar </el-button> -->
          <el-button type="primary" @click="viewRev">EDITAR </el-button>
        </el-col>  
      </el-row>
    </header>
    <!-- Título -->
    <main style="margin:3rem 6rem"> 
      <el-card class="report-title">
        <el-row type="flex" justify="space-between">
          <el-col :span="12">{{ material.originalTitle }}</el-col>
          <!-- <el-col :span="12" class="text-end">REVISADO POR: <span style="font-weight: 500"> {{userLogin}}</span></el-col> -->
        </el-row>          
      </el-card>


     <el-row style="margin: 5rem 3rem 3rem;" v-if="material.reviewObj.userLogin">
        <el-col :span="6">
          <h3 class="bolt-light" >REVISADO POR: </h3>     
        </el-col>
            <el-col :span="10">
              <el-row :span="20" v-for="(item, index) in userReview" :key="index" style="margin-top: 1rem">
              <el-col :span="12" class="text-bold" >{{ item.user }}
              </el-col>
              <el-col :span="12"> ({{ item.date }})
              </el-col>
            </el-row>          
        </el-col>
      </el-row>  

    </main>

      <el-main style="margin:3rem 6rem">
        <h3 class="text-orange" style="margin: 2rem 0">DATOS DEL MATERIAL</h3>
        <!-- Código del material, código del contrato -->
        <el-row style="margin-bottom: 1rem">
          <el-col :span="12" v-if="material.codMaterial">
            <el-col :span="24" class="info-title-rev"> 
              <i class="el-icon-edit" style="font-size: 22px; color: #828282"></i>
              <strong>CÓDIGO DEL MATERIAL</strong>
            </el-col>
            <div class="box-info-rev">
              <el-col :span="24" class="row-info-rev">
                <span>{{material.codMaterial}}</span>
              </el-col>
            </div>
          </el-col>
          <el-col :span="12" v-if="material.contractCode">
            <el-col :span="24" class="info-title-rev"> 
              <i class="el-icon-edit" style="font-size: 22px; color: #828282"></i>
              <strong>CÓDIGO DEL CONTRATO</strong>
            </el-col>
            <div class="box-info-rev">
              <el-col :span="24" class="row-info-rev">
                <span>{{material.contractCode}}</span>
              </el-col>
            </div>
          </el-col>
        </el-row>  
        <el-row style="margin-bottom: 1rem">
					<!-- Títulos del material -->
          <el-col :span="12">
            <el-col :span="24" class="info-title-rev">
							<i class="el-icon-edit" style="font-size: 22px; color: #828282"></i>
							<strong>TÍTULOS DEL MATERIAL</strong>
            </el-col>
            <el-row class="box-info-rev">
							<el-col :span="24" class="row-info-rev">
								<span class="fonts-bold-general">Título Original:</span>
								<span>{{material.originalTitle}}</span>
							</el-col>
							<el-col :span="24" class="row-info-rev">
								<span class="fonts-bold-general">Título Español y/o Sugerido:</span>
								<span>{{material.ownTitle}}</span>
							</el-col>
							<el-col :span="24" class="row-info-rev">
								<span class="fonts-bold-general">Título Comercial:</span>
								<span>{{material.listTitle}}</span>
							</el-col>
            </el-row>
          </el-col>
					<!-- Proveedor y producción, estado de emisión -->
          <el-col :span="12">
            <el-col :span="24" class="info-title-rev"> 
              <i class="el-icon-edit" style="font-size: 22px; color: #828282"></i>
              <strong>PROVEEDOR Y PRODUCCIÓN</strong>
            </el-col>
            <el-row class="box-info-rev">
              <el-col :span="24" class="row-info-rev">
                <span class="fonts-bold-general">Proveedor:</span>
                <span>{{material.providerName}}</span>
              </el-col>
              <el-col :span="24" class="row-info-rev">
                <span class="fonts-bold-general">Productora:</span>
                <span>
                  <span v-for="(item, index) in material.reviewObj.arrProdCompany" :key="index"
                    style="margin-bottom:0.5rem">
                    {{item.prodCompany}}<span v-if="index < (material.reviewObj.arrProdCompany.length -1)">, </span>
                  </span>
                </span>
              </el-col>
              <el-col :span="24" class="row-info-rev">
                <span class="fonts-bold-general">Año de Producción:</span>
                <span>{{material.reviewObj.yearProduction}}</span>
              </el-col>
            </el-row>
          </el-col>
        </el-row>
        
        <el-row style="margin-bottom: 1rem">
					<el-col :span="24" class="info-title-rev"> 
						<i class="el-icon-edit" style="font-size: 22px; color: #828282"></i>
						<strong>TEMPORADAS DEL MATERIAL</strong>
					</el-col>
					<div class="box-info-rev">
						<el-col :span="8" v-for="(value, i) in material.numChapters" :key="i">
						<el-row>
							<el-col :span="24" class="row-info-rev">
								<span class="fonts-bold-general">Temporada:</span>
								<span>{{value.season}}</span>
							</el-col>
							<el-col :span="24" class="row-info-rev">
								<span class="fonts-bold-general">Capítulos:</span>
								<span>{{value.chapters}}</span>
							</el-col>
							<el-col :span="24" class="row-info-rev">
								<span class="fonts-bold-general">Tipo de Capítulos:</span>
								<span>{{value.TypeOfChapters}}</span>
							</el-col>
							<hr class="line-r-separate" v-if="material.numChapters.length-1 > i">
						</el-row>
						</el-col>
					</div>
        </el-row>

        <el-row style="margin-bottom: 1rem">
          <el-col :span="12">
            <el-col :span="24" class="info-title-rev"> 
              <i class="el-icon-edit" style="font-size: 22px; color: #828282"></i>
              <strong>ESTADO DE EMISIÓN</strong>
            </el-col>
            <div class="box-info-rev">
              <el-col :span="24" class="row-info-rev">
                <span>{{material.reviewObj.emissionStatus}}</span>
              </el-col>
            </div>
          </el-col>
        </el-row>
      
        <hr class="line-report">
        <h3 class="text-orange" style="margin: 4rem 0 2rem">CAPÍTULOS</h3>
        
				<div v-for="(value, index) in material.numChapters" :key="index" style="margin-bottom: 50px;">
					<div class="box-title-red">
            <h3>TEMPORADA {{value.season}} <span style="font-weight: lighter; margin-left: 15px;">({{value.chapters}} Capítulos)</span></h3>
          </div>
					<el-table style="width: 100%;"
            :data="value.infoByChapter"
            :header-cell-class-name="tableRowClassName"
            border>
						<el-table-column
							label="CAPÍTULO" width="100" fixed>
							<template slot-scope="scope">
								<div class="chapterIndex">{{scope.row.chapter}}</div>
							</template>
						</el-table-column>
						<el-table-column
							label="TÍTULO GENERAL" width="300">
							<template slot-scope="scope">
								{{scope.row.titleChapter}}
							</template>
						</el-table-column>
						<el-table-column
							label="FECHA DE LLEGADA" width="170">
							<template slot-scope="scope">
                <span v-if="scope.row.arrivalDateString !== 'Invalid Date'">{{scope.row.arrivalDateString}}</span>
                <span v-else></span>
              </template>
						</el-table-column>
						<el-table-column
							label="MODO DE ENVÍO" width="150">
							<template slot-scope="scope">
                	{{scope.row.shippingMode}}
							</template>
						</el-table-column>

						<el-table-column
							label="SOPORTE" width="130">
							<template slot-scope="scope">
                	{{scope.row.support}}
							</template>
						</el-table-column>

          	<el-table-column
              v-if="material.materialType !== 'Fusión Gourmet'"
							label="N° DE BLOQUES" prop="numberBloques" width="150">		
						</el-table-column>
						<el-table-column
							label="DURACIÓN" width="169">
							<template slot-scope="scope">
								<div>
                  {{timeText(scope.row)}}
								</div>
							</template>
						</el-table-column>
					</el-table>
				</div>
        
      </el-main>
  </div>
</template>

<script>
// @ is an alias to /src
import ReturnButton from '@/components/ReturnButton.vue'

export default {
  components: {
    ReturnButton
  },
  data () {
    return {
      material: {},
      stateObs: 0,
      previousInfor: {},
      userLogin: localStorage.getItem('userName'),
      userReview: []
    }
  },
  created () {
    this.materialObj()
  },
  methods: {
    timeText(time) {
      const {hourDuration, minDuration, secDuration} = time
      let res = []
      if(hourDuration && hourDuration !== '' || minDuration && minDuration !== '' || secDuration && secDuration !== '') {
        if(hourDuration && hourDuration !== '') {
          res.push(hourDuration+'h')
        } else {
          res.push('00h')
        }

        if(minDuration && minDuration !== '') {
          res.push(minDuration+'min')
        } else {
          res.push('00min')
        }

        if(secDuration && secDuration !== '') {
          res.push(secDuration+'s')
        } else {
          res.push('0s')
        }
      }
      
      return res.join(' ')
    },
    materialObj () {
      let observations = (JSON.parse(this.$localStorage.get("selectedMaterial")).reviewObj.observations)?JSON.parse(this.$localStorage.get("selectedMaterial")).reviewObj.observations:''
      this.userReview = JSON.parse(this.$localStorage.get("selectedMaterial")).reviewObj.userLogin

      for (var i = 0; i < observations.length; i++) {
        if (observations[i].status === 'En espera de Reposición') {
          this.stateObs++
        }
      }

      this.material = JSON.parse(this.$localStorage.get("selectedMaterial"))
    },
    viewList () {
      // 
      let routePart = this.material.materialType;
      if(routePart == 'Fusión Gourmet'){
        routePart = 'fusionGourmet'
      }
      else {
        if(routePart == 'Producción Nacional') {
          switch(this.material.typeOfContent) {
          // case 'Especial':
          //   routePart = 'specials'
          // break;
            case 'Novelas':
              routePart = 'cartoons'
            break;
            // case 'Dibujos':
            //   routePart = 'cartoons'
            // break;
            case 'Series':
              routePart = 'cartoons'
            break;
            case 'Especial':
              routePart = 'fusionGourmet'
            break;
          // case 'Largometrajes':
          //   routePart = 'largometrajes'
          // break;
          // case 'Miniseries':
          //   routePart = 'miniseries'
          // break;
          // default:
          //   routePart = 'fusionGourmet'
          // break;
        }
      }
      }
      this.$router.push({ name: routePart, params: {name: this.material.typeOfContent }});
    },
    viewRev () {
      this.$router.push({name: 'revFusionGourmet'})
    },
    tableRowClassName ({row, rowIndex}) {
      if (rowIndex === 0) {
        return 'bg-light-red';
      }
    }
  }
}
</script>

<style>
  .el-button.btn-edit-report, .el-button.btn-edit-report:hover, .el-button.btn-edit-report:focus{
    text-transform: uppercase;
    font-weight: 500;
    margin-right: 10px;
    border: 1px solid #ff5000;
    background: transparent;
  }
  .report-title .el-card__body{
    padding: 10px 20px;
    color: white;
    border-radius: 0;
    text-transform: uppercase;
    font-size: 18px;
  }
  .report-title.el-card{
    border-radius: 0;
    box-shadow: 0 0 0 0 transparent;
    background: #828282;
  }
  .info-title-rev{
    padding: 10px 10px 20px 20px;
  }
  .box-info-rev{
    padding: 10px 10px 10px 50px;
  }
  .row-info-rev{
    margin-bottom: 10px;
  }
  .row-info-rev .fonts-bold-general{
    margin-right: 15px;
  }
  .info-title-rev strong{
    margin-left: 8px;
  }
  .margin-conditional{
    margin: 0 0 2rem !important;
  }
	.chapterIndex{
		color: #ff5000;
		font-weight: 500;
	}
	.line-r-separate{
		transform: rotate(90deg);
    position: absolute;
    right: -28px;
    width: 32%;
    bottom: 42px;
	}
</style>
